# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Union
from pydantic.v1 import StrictStr, Field, Field, StrictFloat, StrictInt, StrictStr, constr, validator 
from lusid.models.append_market_data import AppendMarketData

class AppendFxForwardTenorPipsCurveData(AppendMarketData):
    """
    Used to append a new point to an FX curve defined using `FxForwardTenorPipsCurveData`.  # noqa: E501
    """
    tenor:  StrictStr = Field(...,alias="tenor", description="Tenor for which the forward rate applies.") 
    pip_rate: Union[StrictFloat, StrictInt] = Field(..., alias="pipRate", description="Rate provided for the fx forward (price in FgnCcy per unit of DomCcy), expressed in pips.")
    market_data_type:  StrictStr = Field(...,alias="marketDataType", description="The available values are: AppendFxForwardCurveByQuoteReference, AppendFxForwardCurveData, AppendFxForwardPipsCurveData, AppendFxForwardTenorCurveData, AppendFxForwardTenorPipsCurveData") 
    additional_properties: Dict[str, Any] = {}
    __properties = ["marketDataType", "tenor", "pipRate"]

    @validator('market_data_type')
    def market_data_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('AppendFxForwardCurveByQuoteReference', 'AppendFxForwardCurveData', 'AppendFxForwardPipsCurveData', 'AppendFxForwardTenorCurveData', 'AppendFxForwardTenorPipsCurveData'):
            raise ValueError("must be one of enum values ('AppendFxForwardCurveByQuoteReference', 'AppendFxForwardCurveData', 'AppendFxForwardPipsCurveData', 'AppendFxForwardTenorCurveData', 'AppendFxForwardTenorPipsCurveData')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AppendFxForwardTenorPipsCurveData:
        """Create an instance of AppendFxForwardTenorPipsCurveData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AppendFxForwardTenorPipsCurveData:
        """Create an instance of AppendFxForwardTenorPipsCurveData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AppendFxForwardTenorPipsCurveData.parse_obj(obj)

        _obj = AppendFxForwardTenorPipsCurveData.parse_obj({
            "market_data_type": obj.get("marketDataType"),
            "tenor": obj.get("tenor"),
            "pip_rate": obj.get("pipRate")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj
